/*============================================================================
                          LIST CLASS
File name: "list_module.cpp" Not to be modified. It is used by other programs.
------------------------------------------------------------------------------
The elements of the list have type Values. The type Values has to be
instantiated via, for instance:
        typedef int Values;         <--- before: #include  "list_module.cpp"
for having a list of type int. This list_module can be used by writing:
        #include "list_module.cpp"  <--- after:  typedef int Values
=========================================================================== */
#include  <iostream.h>
class cell                               // <-- cell: same name of constructor
{public : 
   Values atom; cell* next;
   cell(Values at, cell* nx) : atom(at), next(nx) { }; // <-- cell constructor
};
typedef cell* list;
//----------------------------------------------------------------------------
//                    head, tail, and cons functions
Values head(list L)
{ if (L == NULL) {cout << "\n error: head of empty list \n";}
  else {return L->atom;};}

list tail(list L)
{ if (L == NULL) {cout << "\n error: tail of empty list \n";}
  else {return L->next;};}

list cons(Values x, list L)
{list newlist = new cell(x,L); return newlist;}
//----------------------------------------------------------------------------
//                    member function
bool member(Values e, list L)
{if (L == NULL) {return false;}
 else if (head(L) == e) {return true;}
 else {return member(e,tail(L));}}
//----------------------------------------------------------------------------
//                    printlist function
// Assume that head(L) is printable `as it is'.
void printlist (list L)
{if (L == NULL) {cout << "nil"; return;}
 else {cout << head(L) << "->";  printlist(tail(L));};}
//----------------------------------------------------------------------------
//                    printlist_as_set function
// Assume that head(L) is printable `as it is'.
void printlistasset (list L)
{cout << "{";
while (L != NULL)
{cout << head(L); L=tail(L); if (L != NULL) {cout << ", ";};}; cout << "}";}
//----------------------------------------------------------------------------